/* board-view.c generated by valac 0.45.91, the Vala compiler
 * generated from board-view.vala, do not modify */

/*
 * Copyright (C) 2018 Robert Roth
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <math.h>
#include <float.h>
#include <gdk/gdk.h>

#define TYPE_BOARD_VIEW (board_view_get_type ())
#define BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW, BoardView))
#define IS_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW))
#define BOARD_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BOARD_VIEW, BoardViewIface))

typedef struct _BoardView BoardView;
typedef struct _BoardViewIface BoardViewIface;

#define TYPE_PUZZLE_GENERATOR (puzzle_generator_get_type ())
#define PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGenerator))
#define PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))
#define IS_PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_GENERATOR))
#define IS_PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_GENERATOR))
#define PUZZLE_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))

typedef struct _PuzzleGenerator PuzzleGenerator;
typedef struct _PuzzleGeneratorClass PuzzleGeneratorClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	BOARD_VIEW_GAME_WON_SIGNAL,
	BOARD_VIEW_LIGHT_TOGGLED_SIGNAL,
	BOARD_VIEW_NUM_SIGNALS
};
static guint board_view_signals[BOARD_VIEW_NUM_SIGNALS] = {0};

struct _BoardViewIface {
	GTypeInterface parent_iface;
	gint (*get_moves) (BoardView* self);
	PuzzleGenerator* (*get_puzzle_generator) (BoardView* self);
	void (*clear_level) (BoardView* self);
	void (*toggle_light) (BoardView* self, gint x, gint y, gboolean user_initiated);
	void (*increase_moves) (BoardView* self);
	gboolean (*is_light_active) (BoardView* self, gint x, gint y);
	GObject* (*get_light_at) (BoardView* self, gint x, gint y);
};

GType puzzle_generator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleGenerator, g_object_unref)
GType board_view_get_type (void) G_GNUC_CONST;
gint board_view_get_moves (BoardView* self);
PuzzleGenerator* board_view_get_puzzle_generator (BoardView* self);
void board_view_clear_level (BoardView* self);
void board_view_toggle_light (BoardView* self,
                              gint x,
                              gint y,
                              gboolean user_initiated);
void board_view_increase_moves (BoardView* self);
gboolean board_view_is_light_active (BoardView* self,
                                     gint x,
                                     gint y);
GObject* board_view_get_light_at (BoardView* self,
                                  gint x,
                                  gint y);
void board_view_load_level (BoardView* self,
                            gint level);
gboolean* puzzle_generator_minimal_solution (PuzzleGenerator* self,
                                             gint solution_length,
                                             gint* result_length1,
                                             gint* result_length2);
#define BOARD_VIEW_size 5
void board_view_handle_toggle (BoardView* self,
                               GObject* light);
void board_view_find_light (BoardView* self,
                            GObject* light,
                            gint* x,
                            gint* y);
void board_view_move_to (BoardView* self,
                         gint x,
                         gint y);
gboolean board_view_is_completed (BoardView* self);
static gboolean board_view_game_won_timeout (BoardView* self);
static gboolean _board_view_game_won_timeout_gsource_func (gpointer self);

gint
board_view_get_moves (BoardView* self)
{
#line 14 "../src/board-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 14 "../src/board-view.vala"
	return BOARD_VIEW_GET_INTERFACE (self)->get_moves (self);
#line 101 "board-view.c"
}

PuzzleGenerator*
board_view_get_puzzle_generator (BoardView* self)
{
#line 15 "../src/board-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "../src/board-view.vala"
	return BOARD_VIEW_GET_INTERFACE (self)->get_puzzle_generator (self);
#line 111 "board-view.c"
}

void
board_view_clear_level (BoardView* self)
{
#line 16 "../src/board-view.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/board-view.vala"
	BOARD_VIEW_GET_INTERFACE (self)->clear_level (self);
#line 121 "board-view.c"
}

void
board_view_toggle_light (BoardView* self,
                         gint x,
                         gint y,
                         gboolean user_initiated)
{
#line 17 "../src/board-view.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/board-view.vala"
	BOARD_VIEW_GET_INTERFACE (self)->toggle_light (self, x, y, user_initiated);
#line 134 "board-view.c"
}

void
board_view_increase_moves (BoardView* self)
{
#line 18 "../src/board-view.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/board-view.vala"
	BOARD_VIEW_GET_INTERFACE (self)->increase_moves (self);
#line 144 "board-view.c"
}

gboolean
board_view_is_light_active (BoardView* self,
                            gint x,
                            gint y)
{
#line 19 "../src/board-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 19 "../src/board-view.vala"
	return BOARD_VIEW_GET_INTERFACE (self)->is_light_active (self, x, y);
#line 156 "board-view.c"
}

GObject*
board_view_get_light_at (BoardView* self,
                         gint x,
                         gint y)
{
#line 21 "../src/board-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/board-view.vala"
	return BOARD_VIEW_GET_INTERFACE (self)->get_light_at (self, x, y);
#line 168 "board-view.c"
}

void
board_view_load_level (BoardView* self,
                       gint level)
{
	gint solution_length = 0;
	gboolean* sol = NULL;
	PuzzleGenerator* _tmp0_;
	PuzzleGenerator* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean* _tmp4_;
	gboolean* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	gint sol_length1;
	gint sol_length2;
#line 33 "../src/board-view.vala"
	if (level < 1) {
#line 34 "../src/board-view.vala"
		level = 1;
#line 191 "board-view.c"
	}
#line 36 "../src/board-view.vala"
	board_view_clear_level (self);
#line 38 "../src/board-view.vala"
	g_random_set_seed ((guint32) level);
#line 41 "../src/board-view.vala"
	solution_length = (gint) floor ((2 * log ((gdouble) level)) + 1);
#line 44 "../src/board-view.vala"
	_tmp0_ = board_view_get_puzzle_generator (self);
#line 44 "../src/board-view.vala"
	_tmp1_ = _tmp0_;
#line 44 "../src/board-view.vala"
	_tmp4_ = puzzle_generator_minimal_solution (_tmp1_, solution_length, &_tmp2_, &_tmp3_);
#line 44 "../src/board-view.vala"
	_tmp5_ = _tmp4_;
#line 44 "../src/board-view.vala"
	_tmp5__length1 = _tmp2_;
#line 44 "../src/board-view.vala"
	_tmp5__length2 = _tmp3_;
#line 44 "../src/board-view.vala"
	_g_object_unref0 (_tmp1_);
#line 44 "../src/board-view.vala"
	sol = _tmp5_;
#line 44 "../src/board-view.vala"
	sol_length1 = _tmp5__length1;
#line 44 "../src/board-view.vala"
	sol_length2 = _tmp5__length2;
#line 219 "board-view.c"
	{
		gint x = 0;
#line 45 "../src/board-view.vala"
		x = 0;
#line 224 "board-view.c"
		{
			gboolean _tmp6_ = FALSE;
#line 45 "../src/board-view.vala"
			_tmp6_ = TRUE;
#line 45 "../src/board-view.vala"
			while (TRUE) {
#line 45 "../src/board-view.vala"
				if (!_tmp6_) {
#line 233 "board-view.c"
					gint _tmp7_;
#line 45 "../src/board-view.vala"
					_tmp7_ = x;
#line 45 "../src/board-view.vala"
					x = _tmp7_ + 1;
#line 239 "board-view.c"
				}
#line 45 "../src/board-view.vala"
				_tmp6_ = FALSE;
#line 45 "../src/board-view.vala"
				if (!(x < BOARD_VIEW_size)) {
#line 45 "../src/board-view.vala"
					break;
#line 247 "board-view.c"
				}
				{
					gint y = 0;
#line 46 "../src/board-view.vala"
					y = 0;
#line 253 "board-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 46 "../src/board-view.vala"
						_tmp8_ = TRUE;
#line 46 "../src/board-view.vala"
						while (TRUE) {
#line 260 "board-view.c"
							gboolean* _tmp10_;
							gint _tmp10__length1;
							gint _tmp10__length2;
							gboolean _tmp11_;
#line 46 "../src/board-view.vala"
							if (!_tmp8_) {
#line 267 "board-view.c"
								gint _tmp9_;
#line 46 "../src/board-view.vala"
								_tmp9_ = y;
#line 46 "../src/board-view.vala"
								y = _tmp9_ + 1;
#line 273 "board-view.c"
							}
#line 46 "../src/board-view.vala"
							_tmp8_ = FALSE;
#line 46 "../src/board-view.vala"
							if (!(y < BOARD_VIEW_size)) {
#line 46 "../src/board-view.vala"
								break;
#line 281 "board-view.c"
							}
#line 47 "../src/board-view.vala"
							_tmp10_ = sol;
#line 47 "../src/board-view.vala"
							_tmp10__length1 = sol_length1;
#line 47 "../src/board-view.vala"
							_tmp10__length2 = sol_length2;
#line 47 "../src/board-view.vala"
							_tmp11_ = _tmp10_[(x * _tmp10__length2) + y];
#line 47 "../src/board-view.vala"
							if (_tmp11_) {
#line 48 "../src/board-view.vala"
								board_view_toggle_light (self, x, y, FALSE);
#line 295 "board-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 30 "../src/board-view.vala"
	sol = (g_free (sol), NULL);
#line 305 "board-view.c"
}

void
board_view_handle_toggle (BoardView* self,
                          GObject* light)
{
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 51 "../src/board-view.vala"
	g_return_if_fail (light != NULL);
#line 54 "../src/board-view.vala"
	board_view_find_light (self, light, &_tmp0_, &_tmp1_);
#line 54 "../src/board-view.vala"
	x = _tmp0_;
#line 54 "../src/board-view.vala"
	y = _tmp1_;
#line 55 "../src/board-view.vala"
	board_view_move_to (self, x, y);
#line 326 "board-view.c"
}

void
board_view_find_light (BoardView* self,
                       GObject* light,
                       gint* x,
                       gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
#line 58 "../src/board-view.vala"
	g_return_if_fail (light != NULL);
#line 60 "../src/board-view.vala"
	_vala_y = 0;
#line 60 "../src/board-view.vala"
	_vala_x = _vala_y;
#line 343 "board-view.c"
	{
		gboolean _tmp0_ = FALSE;
#line 61 "../src/board-view.vala"
		_vala_x = 0;
#line 61 "../src/board-view.vala"
		_tmp0_ = TRUE;
#line 61 "../src/board-view.vala"
		while (TRUE) {
#line 61 "../src/board-view.vala"
			if (!_tmp0_) {
#line 354 "board-view.c"
				gint _tmp1_;
#line 61 "../src/board-view.vala"
				_tmp1_ = _vala_x;
#line 61 "../src/board-view.vala"
				_vala_x = _tmp1_ + 1;
#line 360 "board-view.c"
			}
#line 61 "../src/board-view.vala"
			_tmp0_ = FALSE;
#line 61 "../src/board-view.vala"
			if (!(_vala_x < BOARD_VIEW_size)) {
#line 61 "../src/board-view.vala"
				break;
#line 368 "board-view.c"
			}
			{
				gboolean _tmp2_ = FALSE;
#line 62 "../src/board-view.vala"
				_vala_y = 0;
#line 62 "../src/board-view.vala"
				_tmp2_ = TRUE;
#line 62 "../src/board-view.vala"
				while (TRUE) {
#line 378 "board-view.c"
					GObject* _tmp4_;
					GObject* _tmp5_;
					gboolean _tmp6_;
#line 62 "../src/board-view.vala"
					if (!_tmp2_) {
#line 384 "board-view.c"
						gint _tmp3_;
#line 62 "../src/board-view.vala"
						_tmp3_ = _vala_y;
#line 62 "../src/board-view.vala"
						_vala_y = _tmp3_ + 1;
#line 390 "board-view.c"
					}
#line 62 "../src/board-view.vala"
					_tmp2_ = FALSE;
#line 62 "../src/board-view.vala"
					if (!(_vala_y < BOARD_VIEW_size)) {
#line 62 "../src/board-view.vala"
						break;
#line 398 "board-view.c"
					}
#line 63 "../src/board-view.vala"
					_tmp4_ = board_view_get_light_at (self, _vala_x, _vala_y);
#line 63 "../src/board-view.vala"
					_tmp5_ = _tmp4_;
#line 63 "../src/board-view.vala"
					_tmp6_ = _tmp5_ == light;
#line 63 "../src/board-view.vala"
					_g_object_unref0 (_tmp5_);
#line 63 "../src/board-view.vala"
					if (_tmp6_) {
#line 64 "../src/board-view.vala"
						if (x) {
#line 64 "../src/board-view.vala"
							*x = _vala_x;
#line 414 "board-view.c"
						}
#line 64 "../src/board-view.vala"
						if (y) {
#line 64 "../src/board-view.vala"
							*y = _vala_y;
#line 420 "board-view.c"
						}
#line 64 "../src/board-view.vala"
						return;
#line 424 "board-view.c"
					}
				}
			}
		}
	}
#line 58 "../src/board-view.vala"
	if (x) {
#line 58 "../src/board-view.vala"
		*x = _vala_x;
#line 434 "board-view.c"
	}
#line 58 "../src/board-view.vala"
	if (y) {
#line 58 "../src/board-view.vala"
		*y = _vala_y;
#line 440 "board-view.c"
	}
}

static gboolean
_board_view_game_won_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = board_view_game_won_timeout ((BoardView*) self);
#line 73 "../src/board-view.vala"
	return result;
#line 451 "board-view.c"
}

void
board_view_move_to (BoardView* self,
                    gint x,
                    gint y)
{
#line 69 "../src/board-view.vala"
	board_view_toggle_light (self, x, y, TRUE);
#line 70 "../src/board-view.vala"
	board_view_increase_moves (self);
#line 71 "../src/board-view.vala"
	g_signal_emit (self, board_view_signals[BOARD_VIEW_LIGHT_TOGGLED_SIGNAL], 0);
#line 72 "../src/board-view.vala"
	if (board_view_is_completed (self)) {
#line 73 "../src/board-view.vala"
		gdk_threads_add_timeout ((guint) 300, _board_view_game_won_timeout_gsource_func, self);
#line 469 "board-view.c"
	}
}

static gboolean
board_view_game_won_timeout (BoardView* self)
{
	gboolean result = FALSE;
#line 78 "../src/board-view.vala"
	g_signal_emit (self, board_view_signals[BOARD_VIEW_GAME_WON_SIGNAL], 0);
#line 79 "../src/board-view.vala"
	result = G_SOURCE_REMOVE;
#line 79 "../src/board-view.vala"
	return result;
#line 483 "board-view.c"
}

gboolean
board_view_is_completed (BoardView* self)
{
	gboolean result = FALSE;
	{
		gint x = 0;
#line 84 "../src/board-view.vala"
		x = 0;
#line 494 "board-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 84 "../src/board-view.vala"
			_tmp0_ = TRUE;
#line 84 "../src/board-view.vala"
			while (TRUE) {
#line 84 "../src/board-view.vala"
				if (!_tmp0_) {
#line 503 "board-view.c"
					gint _tmp1_;
#line 84 "../src/board-view.vala"
					_tmp1_ = x;
#line 84 "../src/board-view.vala"
					x = _tmp1_ + 1;
#line 509 "board-view.c"
				}
#line 84 "../src/board-view.vala"
				_tmp0_ = FALSE;
#line 84 "../src/board-view.vala"
				if (!(x < BOARD_VIEW_size)) {
#line 84 "../src/board-view.vala"
					break;
#line 517 "board-view.c"
				}
				{
					gint y = 0;
#line 85 "../src/board-view.vala"
					y = 0;
#line 523 "board-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 85 "../src/board-view.vala"
						_tmp2_ = TRUE;
#line 85 "../src/board-view.vala"
						while (TRUE) {
#line 85 "../src/board-view.vala"
							if (!_tmp2_) {
#line 532 "board-view.c"
								gint _tmp3_;
#line 85 "../src/board-view.vala"
								_tmp3_ = y;
#line 85 "../src/board-view.vala"
								y = _tmp3_ + 1;
#line 538 "board-view.c"
							}
#line 85 "../src/board-view.vala"
							_tmp2_ = FALSE;
#line 85 "../src/board-view.vala"
							if (!(y < BOARD_VIEW_size)) {
#line 85 "../src/board-view.vala"
								break;
#line 546 "board-view.c"
							}
#line 86 "../src/board-view.vala"
							if (board_view_is_light_active (self, x, y)) {
#line 87 "../src/board-view.vala"
								result = FALSE;
#line 87 "../src/board-view.vala"
								return result;
#line 554 "board-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 89 "../src/board-view.vala"
	result = TRUE;
#line 89 "../src/board-view.vala"
	return result;
#line 566 "board-view.c"
}

static void
board_view_default_init (BoardViewIface * iface,
                         gpointer iface_data)
{
#line 10 "../src/board-view.vala"
	board_view_signals[BOARD_VIEW_GAME_WON_SIGNAL] = g_signal_new ("game-won", TYPE_BOARD_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 10 "../src/board-view.vala"
	board_view_signals[BOARD_VIEW_LIGHT_TOGGLED_SIGNAL] = g_signal_new ("light-toggled", TYPE_BOARD_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 577 "board-view.c"
}

GType
board_view_get_type (void)
{
	static volatile gsize board_view_type_id__volatile = 0;
	if (g_once_init_enter (&board_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoardViewIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) board_view_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType board_view_type_id;
		board_view_type_id = g_type_register_static (G_TYPE_INTERFACE, "BoardView", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (board_view_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&board_view_type_id__volatile, board_view_type_id);
	}
	return board_view_type_id__volatile;
}

