/* game-view.c generated by valac 0.45.91, the Vala compiler
 * generated from game-view.vala, do not modify */

/*
 * Copyright (C) 2018 Robert Roth
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>

#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_GAME_VIEW, GameViewIface))

typedef struct _GameView GameView;
typedef struct _GameViewIface GameViewIface;

#define TYPE_BOARD_VIEW (board_view_get_type ())
#define BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW, BoardView))
#define IS_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW))
#define BOARD_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BOARD_VIEW, BoardViewIface))

typedef struct _BoardView BoardView;
typedef struct _BoardViewIface BoardViewIface;

#define TYPE_PUZZLE_GENERATOR (puzzle_generator_get_type ())
#define PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGenerator))
#define PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))
#define IS_PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_GENERATOR))
#define IS_PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_GENERATOR))
#define PUZZLE_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))

typedef struct _PuzzleGenerator PuzzleGenerator;
typedef struct _PuzzleGeneratorClass PuzzleGeneratorClass;
typedef enum  {
	GAME_VIEW_REPLACE_STYLE_REFRESH,
	GAME_VIEW_REPLACE_STYLE_SLIDE_FORWARD,
	GAME_VIEW_REPLACE_STYLE_SLIDE_BACKWARD,
	GAME_VIEW_REPLACE_STYLE_SLIDE_NEXT
} GameViewReplaceStyle;

#define GAME_VIEW_TYPE_REPLACE_STYLE (game_view_replace_style_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GAME_VIEW_LEVEL_CHANGED_SIGNAL,
	GAME_VIEW_MOVES_CHANGED_SIGNAL,
	GAME_VIEW_NUM_SIGNALS
};
static guint game_view_signals[GAME_VIEW_NUM_SIGNALS] = {0};

struct _BoardViewIface {
	GTypeInterface parent_iface;
	gint (*get_moves) (BoardView* self);
	PuzzleGenerator* (*get_puzzle_generator) (BoardView* self);
	void (*clear_level) (BoardView* self);
	void (*toggle_light) (BoardView* self, gint x, gint y, gboolean user_initiated);
	void (*increase_moves) (BoardView* self);
	gboolean (*is_light_active) (BoardView* self, gint x, gint y);
	GObject* (*get_light_at) (BoardView* self, gint x, gint y);
};

struct _GameViewIface {
	GTypeInterface parent_iface;
	void (*replace_board) (GameView* self, BoardView* board_biew, BoardView* new_board_view, GameViewReplaceStyle style, gboolean fast);
	gboolean (*hide_cursor) (GameView* self);
	gboolean (*activate_cursor) (GameView* self);
	gboolean (*move_cursor) (GameView* self, gint x, gint y);
	void (*reset_game) (GameView* self);
	BoardView* (*get_board_view) (GameView* self);
	gboolean (*is_transitioning) (GameView* self);
	gint (*next_level) (GameView* self, gint direction);
	BoardView* (*create_board_view) (GameView* self, gint level);
};

GType puzzle_generator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleGenerator, g_object_unref)
GType board_view_get_type (void) G_GNUC_CONST;
GType game_view_replace_style_get_type (void) G_GNUC_CONST;
GType game_view_get_type (void) G_GNUC_CONST;
void game_view_replace_board (GameView* self,
                              BoardView* board_biew,
                              BoardView* new_board_view,
                              GameViewReplaceStyle style,
                              gboolean fast);
gboolean game_view_hide_cursor (GameView* self);
gboolean game_view_activate_cursor (GameView* self);
gboolean game_view_move_cursor (GameView* self,
                                gint x,
                                gint y);
void game_view_reset_game (GameView* self);
BoardView* game_view_get_board_view (GameView* self);
gboolean game_view_is_transitioning (GameView* self);
gint game_view_next_level (GameView* self,
                           gint direction);
BoardView* game_view_create_board_view (GameView* self,
                                        gint level);
void game_view_swap_board (GameView* self,
                           gint direction);
void game_view_game_won_cb (GameView* self);
void game_view_light_toggled_cb (GameView* self);
gint board_view_get_moves (BoardView* self);

GType
game_view_replace_style_get_type (void)
{
	static volatile gsize game_view_replace_style_type_id__volatile = 0;
	if (g_once_init_enter (&game_view_replace_style_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_VIEW_REPLACE_STYLE_REFRESH, "GAME_VIEW_REPLACE_STYLE_REFRESH", "refresh"}, {GAME_VIEW_REPLACE_STYLE_SLIDE_FORWARD, "GAME_VIEW_REPLACE_STYLE_SLIDE_FORWARD", "slide-forward"}, {GAME_VIEW_REPLACE_STYLE_SLIDE_BACKWARD, "GAME_VIEW_REPLACE_STYLE_SLIDE_BACKWARD", "slide-backward"}, {GAME_VIEW_REPLACE_STYLE_SLIDE_NEXT, "GAME_VIEW_REPLACE_STYLE_SLIDE_NEXT", "slide-next"}, {0, NULL, NULL}};
		GType game_view_replace_style_type_id;
		game_view_replace_style_type_id = g_enum_register_static ("GameViewReplaceStyle", values);
		g_once_init_leave (&game_view_replace_style_type_id__volatile, game_view_replace_style_type_id);
	}
	return game_view_replace_style_type_id__volatile;
}

void
game_view_replace_board (GameView* self,
                         BoardView* board_biew,
                         BoardView* new_board_view,
                         GameViewReplaceStyle style,
                         gboolean fast)
{
#line 19 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/game-view.vala"
	GAME_VIEW_GET_INTERFACE (self)->replace_board (self, board_biew, new_board_view, style, fast);
#line 135 "game-view.c"
}

gboolean
game_view_hide_cursor (GameView* self)
{
#line 21 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 21 "../src/game-view.vala"
	return GAME_VIEW_GET_INTERFACE (self)->hide_cursor (self);
#line 145 "game-view.c"
}

gboolean
game_view_activate_cursor (GameView* self)
{
#line 22 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22 "../src/game-view.vala"
	return GAME_VIEW_GET_INTERFACE (self)->activate_cursor (self);
#line 155 "game-view.c"
}

gboolean
game_view_move_cursor (GameView* self,
                       gint x,
                       gint y)
{
#line 23 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 23 "../src/game-view.vala"
	return GAME_VIEW_GET_INTERFACE (self)->move_cursor (self, x, y);
#line 167 "game-view.c"
}

void
game_view_reset_game (GameView* self)
{
#line 24 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/game-view.vala"
	GAME_VIEW_GET_INTERFACE (self)->reset_game (self);
#line 177 "game-view.c"
}

BoardView*
game_view_get_board_view (GameView* self)
{
#line 25 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/game-view.vala"
	return GAME_VIEW_GET_INTERFACE (self)->get_board_view (self);
#line 187 "game-view.c"
}

gboolean
game_view_is_transitioning (GameView* self)
{
#line 26 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../src/game-view.vala"
	return GAME_VIEW_GET_INTERFACE (self)->is_transitioning (self);
#line 197 "game-view.c"
}

gint
game_view_next_level (GameView* self,
                      gint direction)
{
#line 27 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/game-view.vala"
	return GAME_VIEW_GET_INTERFACE (self)->next_level (self, direction);
#line 208 "game-view.c"
}

BoardView*
game_view_create_board_view (GameView* self,
                             gint level)
{
#line 28 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/game-view.vala"
	return GAME_VIEW_GET_INTERFACE (self)->create_board_view (self, level);
#line 219 "game-view.c"
}

void
game_view_swap_board (GameView* self,
                      gint direction)
{
	GameViewReplaceStyle _tmp0_ = 0;
	BoardView* _tmp1_;
	BoardView* _tmp2_;
	BoardView* _tmp3_;
	BoardView* _tmp4_;
#line 36 "../src/game-view.vala"
	if (game_view_is_transitioning (self)) {
#line 37 "../src/game-view.vala"
		return;
#line 235 "game-view.c"
	}
#line 40 "../src/game-view.vala"
	if (direction == 1) {
#line 40 "../src/game-view.vala"
		_tmp0_ = GAME_VIEW_REPLACE_STYLE_SLIDE_FORWARD;
#line 241 "game-view.c"
	} else {
#line 41 "../src/game-view.vala"
		_tmp0_ = GAME_VIEW_REPLACE_STYLE_SLIDE_BACKWARD;
#line 245 "game-view.c"
	}
#line 39 "../src/game-view.vala"
	_tmp1_ = game_view_get_board_view (self);
#line 39 "../src/game-view.vala"
	_tmp2_ = _tmp1_;
#line 39 "../src/game-view.vala"
	_tmp3_ = game_view_create_board_view (self, game_view_next_level (self, direction));
#line 39 "../src/game-view.vala"
	_tmp4_ = _tmp3_;
#line 39 "../src/game-view.vala"
	game_view_replace_board (self, _tmp2_, _tmp4_, _tmp0_, TRUE);
#line 39 "../src/game-view.vala"
	_g_object_unref0 (_tmp4_);
#line 39 "../src/game-view.vala"
	_g_object_unref0 (_tmp2_);
#line 261 "game-view.c"
}

void
game_view_game_won_cb (GameView* self)
{
	BoardView* _tmp0_;
	BoardView* _tmp1_;
	BoardView* _tmp2_;
	BoardView* _tmp3_;
#line 48 "../src/game-view.vala"
	if (game_view_is_transitioning (self)) {
#line 49 "../src/game-view.vala"
		return;
#line 275 "game-view.c"
	}
#line 51 "../src/game-view.vala"
	_tmp0_ = game_view_get_board_view (self);
#line 51 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 51 "../src/game-view.vala"
	_tmp2_ = game_view_create_board_view (self, game_view_next_level (self, 1));
#line 51 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 51 "../src/game-view.vala"
	game_view_replace_board (self, _tmp1_, _tmp3_, GAME_VIEW_REPLACE_STYLE_SLIDE_NEXT, TRUE);
#line 51 "../src/game-view.vala"
	_g_object_unref0 (_tmp3_);
#line 51 "../src/game-view.vala"
	_g_object_unref0 (_tmp1_);
#line 291 "game-view.c"
}

void
game_view_light_toggled_cb (GameView* self)
{
	BoardView* _tmp0_;
	BoardView* _tmp1_;
#line 56 "../src/game-view.vala"
	_tmp0_ = game_view_get_board_view (self);
#line 56 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 56 "../src/game-view.vala"
	g_signal_emit (self, game_view_signals[GAME_VIEW_MOVES_CHANGED_SIGNAL], 0, board_view_get_moves (_tmp1_));
#line 56 "../src/game-view.vala"
	_g_object_unref0 (_tmp1_);
#line 307 "game-view.c"
}

static void
game_view_default_init (GameViewIface * iface,
                        gpointer iface_data)
{
#line 10 "../src/game-view.vala"
	game_view_signals[GAME_VIEW_LEVEL_CHANGED_SIGNAL] = g_signal_new ("level-changed", TYPE_GAME_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 10 "../src/game-view.vala"
	game_view_signals[GAME_VIEW_MOVES_CHANGED_SIGNAL] = g_signal_new ("moves-changed", TYPE_GAME_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 318 "game-view.c"
}

GType
game_view_get_type (void)
{
	static volatile gsize game_view_type_id__volatile = 0;
	if (g_once_init_enter (&game_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameViewIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_view_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType game_view_type_id;
		game_view_type_id = g_type_register_static (G_TYPE_INTERFACE, "GameView", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (game_view_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&game_view_type_id__volatile, game_view_type_id);
	}
	return game_view_type_id__volatile;
}

